/* packet-wap.h (c) 1999 B.P. Fowler */
/* $Id: packet-nlm.h,v 1.1 1999/11/15 14:17:19 nneul Exp $ */

#ifndef __PACKET_WAP_H__
#define __PACKET_WAP_H__

#define UDP_PORT_WAP1 9201

/* These definitions taken from the Kannel project (April 2nd 2000) which is under
   BSD licence */


typedef enum {
 TRInvokeIndication , 
 TRInvokeConfirmation , 
 TRResultConfirmation , 
 TRAbortIndication , 
 SMethodAbortRequire , 
 SConnectResponse , 
 Release , 
 SMethodInvokeResult , 
 SMethodResultRequest , 
 WSPEventType_count
} WSPEventType;

enum {
     no_cache = -1,
     iniatilised = -2,
     not_iniatilised = -3,
     cached = 0
};

enum {
     no_cached_tid,
     ok,
     fail
};

/* PDU Types

   See section 9.1 (p. 40) of spec-wtp-19990611.pdf
*/

enum {
     ERRONEOUS = -0x01,
     NOT_ALLOWED = 0x00,
     INVOKE = 0x01,
     RESULT = 0x02,
     ACK = 0x03,
     ABORT = 0x04,
     SEGMENTED_INVOKE = 0x05,
     SEGMENTED_RESULT = 0x06,
     NEGATIVE_ACK = 0x07
};

extern char *pszPDUTypes[ ];
	
enum {
   ACKNOWLEDGEMENT = 0,
   TID_VERIFICATION = 1
};

enum {
     PROVIDER = 0x00,
     USER = 0x01
};

enum event_name {
 RcvInvoke , 
 RcvAbort , 
 RcvAck , 
 TRInvokeRequire , 
 TRInvokeResponse , 
 TRResultRequire , 
 TRAbortRequire ,  
 TimerTO_A , 
 TimerTO_R , 
 TimerTO_W , 
 RcvErrorPDU , 
 event_name_count
};

enum states {
 LISTEN , 
 TIDOK_WAIT , 
 INVOKE_RESP_WAIT , 
 RESULT_WAIT , 
 RESULT_RESP_WAIT , 
 WAIT_TIMEOUT , 
 states_count
};


void
dissect_wap(const u_char *pd, int offset, frame_data *fd, proto_tree *tree); 
void
dissect_wsp(const u_char *pd, int offset, frame_data *fd, proto_tree *tree);

#endif /* packet-wap.h */

